%error = forceRequiredAddOn(Weapon_Gun);
switch(%error)
{
	case $Error::AddOn_Disabled: gunItem.uiName = "";
	case $Error::AddOn_NotFound: return;
}

datablock ItemData(HG_SMGitem : GunItem)
{
	uiName = "SMG";
	colorShiftColor = "0.1 0.1 0.1 1";
	image = HG_SMGimage;
	canDrop = true;
};

datablock ShapeBaseImageData(HG_SMGimage)
{
	shapeFile = "Add-Ons/Weapon_Gun/pistol.dts";
	emap = true;

	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0;
	rotation = "0 0 0";

	correctMuzzleVector = true;

	className = "WeaponImage";

	item = HG_SMGitem;
	ammo = 30; //Clip size
	maxAmmo = 150; //Maximum amount of ammo for this gun
	projectile = gunProjectile;
	projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1 -1.3 1";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15;	
	shellVelocity       = 7;

	melee = false;
	armReady = true;

	doColorShift = true;
	colorShiftColor = HG_SMGitem.colorShiftColor;

	stateName[0]                   = "Activate";
	stateTimeoutValue[0]           = 0.15;
	stateTransitionOnTimeout[0]    = "Ready";
	stateSound[0]                  = weaponSwitchSound;

	stateName[1]                   = "Ready";
	stateTransitionOnTriggerDown[1]= "Fire1";
	stateAllowImageChange[1]       = true;
	stateSequence[1]               = "Ready";

	stateName[2]                   = "Fire1";
	stateTransitionOnTimeout[2]    = "Fire2";
	stateTimeoutValue[2]           = 0.1;
	stateFire[2]                   = true;
	stateAllowImageChange[2]       = false;
	stateSequence[2]               = "Fire";
	stateScript[2]                 = "onFire";
	stateWaitForTimeout[2]         = true;
	stateEmitter[2]                = gunFlashEmitter;
	stateEmitterTime[2]            = 0.05;
	stateEmitterNode[2]            = "muzzleNode";
	stateSound[2]                  = gunShot1Sound;
	stateEjectShell[2]             = true;

	stateName[3]                   = "Fire2";
	stateTransitionOnTimeout[3]    = "Fire3";
	stateTimeoutValue[3]           = 0.1;
	stateFire[3]                   = true;
	stateAllowImageChange[3]       = false;
	stateSequence[3]               = "Fire";
	stateScript[3]                 = "onFire";
	stateWaitForTimeout[3]         = true;
	stateEmitter[3]                = gunFlashEmitter;
	stateEmitterTime[3]            = 0.05;
	stateEmitterNode[3]            = "muzzleNode";
	stateSound[3]                  = gunShot1Sound;
	stateEjectShell[3]             = true;

	stateName[4]                   = "Fire3";
	stateTransitionOnTimeout[4]    = "Smoke";
	stateTimeoutValue[4]           = 0.1;
	stateFire[4]                   = true;
	stateAllowImageChange[4]       = false;
	stateSequence[4]               = "Fire";
	stateScript[4]                 = "onFire";
	stateWaitForTimeout[4]         = true;
	stateEmitter[4]                = gunFlashEmitter;
	stateEmitterTime[4]            = 0.05;
	stateEmitterNode[4]            = "muzzleNode";
	stateSound[4]                  = gunShot1Sound;
	stateEjectShell[4]             = true;

	stateName[5]                   = "Smoke";
	stateEmitter[5]                = gunSmokeEmitter;
	stateEmitterTime[5]            = 0.05;
	stateEmitterNode[5]            = "muzzleNode";
	stateTimeoutValue[5]           = 0.1;
	stateTransitionOnTimeout[5]    = "Reload";

	stateName[6]                   = "Reload";
	stateSequence[6]               = "Reload";
	stateTransitionOnTriggerUp[6]  = "Ready";
	stateTransitionOnTriggerDown[6]= "Fire1";
	stateSequence[6]               = "Ready";
};

function HG_SMGimage::onMount(%this, %obj, %slot)
{
	parent::onMount(%this, %obj, %slot);
	%id = %this.getID();
	if(%obj.session[%id] < 1)
	{
		%obj.ammo[%id] = %this.maxAmmo / 2 - %this.ammo;
		%obj.clip[%id] = %this.ammo;
		%obj.session[%id] = 0;
	}
	%obj.session[%id]++;
	if(%obj.scheds[%id] > 0)
	{
		for(%i = 1; %i <= %obj.scheds[%id]; %i++)
		{
			%obj.schedule((%i * 50) + 7500, loadRound, %this, %obj.session[%id]);
		}
	}
	if(isObject(%client = %obj.getControllingClient()))
	{
		%name = %this.item.uiName;
		%client.bottomprint("\c6" @ %name @ " Ammo: Clip: \c3" @ %obj.clip[%id] @ "\c6 Inventory: \c3" @ %obj.ammo[%id], 15);
	}
}

function HG_SMGimage::onFire(%this, %obj, %slot)
{
	%id = %this.getID();
	%name = %this.item.uiName;
	if(%obj.getDamagePercent() < 1 && %obj.clip[%id] > 0)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, 150);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 0.031415926;
		%y = (getRandom() - 0.5) * 0.031415926;
		%z = (getRandom() - 0.5) * 0.031415926;
		%mat = MatrixCreateFromEuler(%x SPC %y SPC %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new Projectile()
		{
			dataBlock = gunProjectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			client = %obj.client;
			sourceSlot = %slot;
		};
		MissionCleanup.add(%p);
		if(%obj.ammo[%id] > %obj.scheds[%id])
		{
			%obj.scheds[%id]++;
			%obj.schedule(7500, loadRound, %this, %obj.session[%id]);
		}
		%obj.clip[%id]--;
		if(isObject(%client = %obj.getControllingClient()))
		{
			%client.bottomprint("\c6" @ %name @ " Ammo: Clip: \c3" @ %obj.clip[%id] @ "\c6 Inventory: \c3" @ %obj.ammo[%id], 15);
		}
	}
	else
	{
		if(isObject(%client = %obj.getControllingClient()))
		{
			%obj.client.centerPrint("<color:ff0000>No Ammo!", 3);
			%obj.client.bottomprint("\c6" @ %name @ " Ammo: Clip: \c3" @ %obj.clip[%id] @ "\c6 Inventory: \c3" @ %obj.ammo[%id], 15);
		}
	}
}

function Player::LoadRound(%obj, %image, %session)
{
	%id = %image.getID();
	if(%obj.session[%id] == %session || %session == -1)
	{
		if(isObject(%obj))
		{
			if(%obj.getMountedImage(0) != %id)
			{
				return;
			}
			%name = %image.item.uiName;
			serverPlay3d(weaponSwitchSound, %obj.getMuzzlePoint(0));
			%obj.clip[%id]++;
			%obj.ammo[%id]--;
			%obj.scheds[%id]--;
			if(isObject(%client = %obj.getControllingClient()))
			{
				%client.bottomprint("\c6" @ %name @ " Ammo: Clip: \c3" @ %obj.clip[%id] @ "\c6 Inventory: \c3" @ %obj.ammo[%id], 15);
			}
		}
	}
}